# Kamangar, Farhad
# 1000_123_456
# 2024_10_06
# Assignment_04_01

import random
import numpy as np
import torch
from torch import nn
from torchvision.datasets import MNIST
from torchvision.transforms import transforms
from torch.optim import Adam
from torch.utils.data import DataLoader, TensorDataset




def confusion_matrix(y_true, y_pred, n_classes=10):
    #
    # Compute the confusion matrix for a set of predictions
    # Assume that the y_true and y_pred are numpy array with the corresponding class indices.
    # Consider the class with the highest probability from model's output as the predicted class.
    #
    # Hence, the shape of the confusion matrix should be (n_classes, n_classes)
    # The (i, j)th entry should be the number of times an example with true label i was predicted label j
    #
    # Do not use any libraries to use this function (e.g. sklearn.metrics.confusion_matrix, or tensorflow.math.confusion_matrix)
    pass

# This function has been converted from Tensorflow to PyTorch by  Islam, SM Mazharul. 2024_09_19
def train_cnn_torch(train_dl, test_dl, lr=0.01, epochs=1, test_mode=False):
    #
    # Train a convolutional neural network using PyTorch.
    # train_dl: PyTorch data-loader for the training data; Please check the test file to see how the data-loader is implemented
    # test_dl: PyTorch data-loader for the test data
    # lr: learning rate of the optimizer
    # epochs: Number of training epochs
    # test_mode: If "True", for each epoch, your code should only train and test on the first batch from the dataloader;
    # - if "False", train and test on the entire dataset.
    #
    # Your neural network should have this exact architecture (it's okay to hardcode)
    # - Convolutional layer with 8 filters, kernel size 3 by 3, stride 1 by 1, padding 'same'
    # - ReLU activation
    # - 2D Convolutional layer with 16 filters, kernel size 3 by 3, stride 1 by 1, padding 'same'
    # - ReLU activation
    # - 2D Max pooling layer with kernel size 2 and stride 2
    # - 2D Convolutional layer with 32 filters, kernel size 3 by 3, stride 1 by 1, padding 'same'
    # - ReLU activation
    # - 2D Convolutional layer with 64 filters, kernel size 3 by 3 , stride 1 by 1, padding 'same'
    # - ReLU activation
    # - 2D Max pooling layer with kernel size 2 and stride 2
    # - Flatten layer
    # - Linear layer with 512 output units
    # - ReLU activation
    # - Linear layer with 10 output units
    # - Softmax layer
    #
    #
    # The neural network should be trained using the Adam optimizer with the specified learning rate. Leave the other parameters as is.
    # The loss function should be categorical cross-entropy. You can use torch.nn.CrossEntropyLoss for this purpose.
    # This loss should be computed on the entire test dataset, except for the "debug_mode==True", when you only compute the loss for the first batch.
    # The learning rate should be given by the 'lr' parameter.
    # The number of epochs should be given by the 'epochs' parameter.
    #
    # You should compute the confusion matrix on the test set and return it as a numpy array.
    # You should plot the confusion matrix using the matplotlib function matshow (as heat map) and save it to 'confusion_matrix.png'
    # You should save the keras model to a file called 'cnn.pt' (do not submit this file). When we test run your program we will check "cnn.pt"
    # Your program should run uninterrupted and require no user input (including closing figures, etc).
    #
    # You should use this equation for computing accuracy, accuracy = num_of_correct / num_total_samples
    #
    # You will return a list with the following items in the order specified below:
    # - the trained (for epochs > 0) or initialized model (for epochs == 0)
    # - the loss history on the test data set as a numpy array, if epochs == 0, return an empty list or empty numpy array
    # - the confusion matrix as numpy array; if epochs == 0, return None
    # - the accuracy history on the test data set as a numpy array, if epochs == 0, return an empty list or empty numpy array

    pass
